﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Sub Class_Globals
  Private svFD As ScrollView
  Private pnFD As Panel
  Private lbPath As Label

  Type pnRec (lb As Label, iv As ImageView, i As Int, isdir As Boolean)
  Type FDRec (dir As String, fname As String, res As Int)
  
  Dim FDRes As FDRec
  
  Dim btOkSub As String
  Dim btCanSub As String
  
  Dim pnLastSel As Panel
  Dim pnCurrSel As Panel

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(act As Activity)
  Private i, j, lt, wh, tp, ht, aw, ah, lbh As Int
  Private s, pth As String
  Private p1, p2, p3 As Panel
  Private sv As ScrollView
  Private b1, b2, b3 As Button
  Private l1 As Label
  Private m As Map
  
  aw = act.Width
  ah = act.Height
  
  wh = Min(aw * 0.8, 400)
  ht = Min(ah * 0.8, 600)
  If (wh < aw) Then lt = (aw - wh) / 2 Else lt = 0
  If (ht < ah) Then tp = (ah - ht) / 3 Else tp = 0
  
  lbh = 50dip
  
  p1.Initialize("")
  p1.Color = Colors.RGB(153, 180, 209)
  act.AddView(p1, lt, tp, wh, ht)
  pnFD = p1
  
  p2.Initialize("")
  p2.Color = Colors.RGB(153, 180, 209)
  p1.AddView(p2, 0, 0, wh, lbh)
  
  Dim sld As StateListDrawable
  Dim enb, dsb, psd As BitmapDrawable

  enb.Initialize(LoadBitmap(File.DirAssets, "up.png"))
  dsb.Initialize(LoadBitmap(File.DirAssets, "up.png"))
  psd.Initialize(LoadBitmap(File.DirAssets, "up.png"))

  sld.Initialize
  sld.AddState(sld.State_Pressed, psd)
  sld.AddState(sld.State_Enabled, enb)
  sld.AddState(sld.State_Disabled, dsb)

  b1.Initialize("btFDUp")
  b1.Background = sld
  p2.AddView(b1, 0, 0, lbh, lbh)
  
  p3.Initialize("")
  p3.Color = Colors.RGB(153, 180, 209)
  p1.AddView(p3, 0, ht-lbh, wh, lbh)
  
  j = 125dip
  i = (wh - 2*j) / 3
  
  enb.Initialize(LoadBitmap(File.DirAssets, "ok.png"))
  dsb.Initialize(LoadBitmap(File.DirAssets, "ok.png"))
  psd.Initialize(LoadBitmap(File.DirAssets, "ok.png"))

  sld.Initialize
  sld.AddState(sld.State_Pressed, psd)
  sld.AddState(sld.State_Enabled, enb)
  sld.AddState(sld.State_Disabled, dsb)

  b2.Initialize("btFDOk")
  b2.Background = sld
  p3.AddView(b2, i, 0, j, lbh)
  
  enb.Initialize(LoadBitmap(File.DirAssets, "cancel.png"))
  dsb.Initialize(LoadBitmap(File.DirAssets, "cancel.png"))
  psd.Initialize(LoadBitmap(File.DirAssets, "cancel.png"))

  sld.Initialize
  sld.AddState(sld.State_Pressed, psd)
  sld.AddState(sld.State_Enabled, enb)
  sld.AddState(sld.State_Disabled, dsb)

  b3.Initialize("btFDCan")
  b3.Background = sld
  p3.AddView(b3, 2*i+j, 0, j, lbh)
  
  l1.Initialize("")
  l1.TextColor = Colors.White
  l1.TextSize = 16
  l1.Typeface = Typeface.DEFAULT_BOLD
  l1.Text = "Path"
  l1.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
  p2.AddView(l1, lbh+5dip, 0, p2.Width-(lbh+5dip), p2.Height)
  lbPath = l1
  
  i = 3dip
  
  sv.Initialize(ht)
  sv.Color = Colors.White
  p1.AddView(sv, i, p2.Height, wh-2*i, ht-p2.Height-p3.Height)
  sv.Panel.Height = sv.Height
  svFD = sv
  
  pnFD.Enabled = False
  pnFD.Visible = False
  
  pnLastSel = Null
  pnCurrSel = Null
  
  btOkSub = ""
  btCanSub = ""
  
  If (File.Exists(File.DirDefaultExternal, "FileDlg.map") = False) Then
    pth = File.DirRootExternal

    m.Initialize
    m.Put("path", pth)
    File.WriteMap(File.DirDefaultExternal, "FileDlg.map", m)
  End If
End Sub

Sub Show(FDPath As String)
  Dim wh, ht, lbh, imw, imh, res As Int
  Dim s, pth As String
  Dim flst As List
  Dim sv As ScrollView
  Dim m As Map
  Dim cd As CustomDialog
  
  If (pnCurrSel.IsInitialized = True) Then
    Dim p1 As Panel
	Dim l1 As Label
    Dim pnr As pnRec
	
	p1 = pnCurrSel
	pnr = p1.Tag
	l1 = pnr.lb
	
	p1.Color = Colors.RGB(153, 180, 209)
	l1.TextColor = Colors.White
	l1.Typeface = Typeface.DEFAULT_BOLD
	
	If (pnLastSel.IsInitialized = True) Then
	  p1 = pnLastSel
	  pnr = p1.Tag
	  l1 = pnr.lb
	  
	  If ((pnr.i Mod 2) = 0) Then
        p1.Color = Colors.ARGB(255, 255, 255, 255)
	  Else
        p1.Color = Colors.ARGB(255, 248, 248, 255)
	  End If

	  l1.TextColor = Colors.Black
	  l1.Typeface = Typeface.DEFAULT
	  
	  pnLastSel = Null
	End If
	
	Return
  End If
  
  pth = ""
  m.Initialize
  
  If (FDPath = "") Then
    If (File.Exists(File.DirDefaultExternal, "FileDlg.map") = True) Then
      m = File.ReadMap(File.DirDefaultExternal, "FileDlg.map")
	  pth = m.Get("path")
    End If
  Else
    If (File.Exists(FDPath, "") = True) Then
      If (File.IsDirectory(FDPath, "") = True) Then pth = FDPath
	End If
  End If
  
  If (pth = "") Then pth = File.DirRootExternal
  
  lbPath.Text = pth
  m.Put("path", pth)
  File.WriteMap(File.DirDefaultExternal, "FileDlg.map", m)
  
  sv = svFD
  
  For i=sv.Panel.NumberOfViews-1 To 0 Step -1
    sv.Panel.RemoveViewAt(i)
  Next
  
  sv.Panel.Height = sv.Height
  
  flst = File.ListFiles(pth)
  
  wh = sv.Width
  ht = lbPath.Height + sv.Height
  lbh = lbPath.Height
  imw = lbh - 5dip
  imh = lbh - 5dip
  
  If (flst.Size < 1) Then
    s = "No Items in folder"
	
	Dim lb As Label
	lb.Initialize("")
	lb.TextColor = Colors.Black
	lb.TextSize = lbPath.TextSize
	lb.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
	lb.Text = s
    sv.Panel.AddView(lb, 0, sv.Panel.Height/3, wh, lbh)

  Else
    sv.Panel.Height = lbh * flst.Size
	
    For i=0 To flst.Size-1
      s = flst.Get(i)
	  pnLastSel = Null
	  pnCurrSel = Null
	
	  Dim pnr As pnRec
      Dim pn As Panel
      pn.Initialize("FDpn")
	  If ((i Mod 2) = 0) Then
        pn.Color = Colors.ARGB(255, 255, 255, 255)
	  Else
        pn.Color = Colors.ARGB(255, 248, 248, 255)
	  End If
	  pnr.i = i
	  pn.Tag = pnr
      sv.Panel.AddView(pn, 0, lbh*i, wh, lbh)
	  
      Dim lb As Label
	  lb.Initialize("")
      lb.Color = Colors.ARGB(0, 255, 255, 255)
      lb.TextColor = Colors.Black
      lb.TextSize = lbPath.TextSize
      lb.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
      lb.Text = s
	  pnr.lb = lb
      pn.AddView(lb, lbh, 0, wh-lbh, lbh)
	  
	  Dim iv As ImageView
	  iv.Initialize("")
      iv.Gravity = Gravity.FILL
	  pnr.iv = iv
      pn.AddView(iv, (lbh-imw)/2, (lbh-imh)/2, imw, imh)
		
      If (File.isdirectory(pth, s)) Then
        pnr.isdir = True ' is a directory
        iv.Bitmap = LoadBitmap(File.DirAssets, "folder.png") 
      Else
        ' JPEG (.jpg), GIF (.gif), PNG (.png), BMP (.bmp), WebP (.webp)
        pnr.isdir = False ' not a directory
		
        If ( (s.EndsWith(".jpg")) OR (s.EndsWith(".jpg")) OR (s.EndsWith(".jpg")) OR _
          (s.EndsWith(".jpg")) OR (s.EndsWith(".jpg")) ) Then
          iv.Bitmap = LoadBitmap(pth & "/", s)
        Else
          iv.Bitmap = LoadBitmap(File.DirAssets, "file.png") 
        End If
      End If
    Next
  End If

  pnFD.Enabled = True
  pnFD.Visible = True

' comment the following 3 lines for Activity mode
  pnFD.RemoveView ' [cd]
  cd.AddView(pnFD, 0, 0, sv.Width, sv.Height+2*lbPath.Height) ' [cd]
  cd.Show("", "Ok", "Cancel", "", Null) ' [cd]

End Sub

Sub FDpn_Click
  Dim s As String
  Dim l As Label
  Dim p As Panel
  Dim pnr As pnRec

ToastMessageShow("btFDpn_Click", True)

  p = Sender
  pnr = p.Tag
  l = pnr.lb
  
  If (pnr.isdir = True) Then
    pnLastSel = Null
    pnCurrSel = Null
	
	s = lbPath.Text & "/" & l.Text
	
	If (File.Exists(s, "") = True) Then
	  Show(s)
	Else
	  Show(lbPath.Text)
	End If

  Else
    pnLastSel = pnCurrSel
	pnCurrSel = p
	Show("")
  End If
End Sub

Sub btFDUp_Click
  Dim s, t() As String
  Dim lst As List

ToastMessageShow("btFDUp_Click", True)

  s = lbPath.Text
  t = Regex.Split("/", s)
  
  lst.Initialize
  
  For i=0 To t.Length-1
    If (t(i) <> "") Then lst.Add(t(i))
  Next
    
  If (lst.Size <= 1) Then
    s = "/"
  Else
    s = ""
    For i=0 To lst.Size-2
	  s = s & "/" & lst.Get(i)
	Next
  End If
  
  Show(s)
End Sub

Sub btFDOk_Click
  Dim p As Panel
  Dim pnr As pnRec
  Dim l As Label
  
ToastMessageShow("btFDOk_Click", True)

  FDRes.dir = lbPath.Text
  FDRes.res = DialogResponse.POSITIVE
  FDRes.fname = ""
  
  If (pnCurrSel.IsInitialized = True) Then
    p = pnCurrSel
	pnr = p.Tag
	l = pnr.lb
  End If

  pnFD.Enabled = False
  pnFD.Visible = False
  
  CallSub(Main, btOkSub)
End Sub

Sub btFDCan_Click
  FDRes.dir = lbPath.Text
  FDRes.res = DialogResponse.CANCEL
  FDRes.fname = ""
  
ToastMessageShow("btFDCan_Click", True)

  pnFD.Enabled = False
  pnFD.Visible = False
  
  CallSub(Main, btCanSub)
End Sub

